/* $Header: conf.h.dist,v 1.9 91/02/08 18:31:01 sob Exp $
 * Configuration information for use by the client library and support
 * programs.  Change these as appropriate for your system.
 */

/* If you're using a windowing application that can not handle any printf's */
/* then define this */
#undef DONT_ALLOW_PRINTF

/* define for path debugging for spooldir/iso problems */
#undef PATH_DEBUG 1

/* define for rawcheck_server/rawget_server debugging */
#undef RAW_SERVER_DEBUG 1

/*
 * If you want to experiment with the dynamic allocation of the article
 * array, define DYNAMIC_ART_ARRAY.
 * This code came to beta too late for through testing, but it is a problem
 * at some sites, so it is an option. Please report problems to "nntp@tmc.edu"
 */
#undef DYNAMIC_ART_ARRAY

#undef	BSD_42		/* 4.2 compatability code -- if this is defined, */
			/* DBM probably wants to be defined as well. */

#define BSD_43		/* Define if you are running on BSD 4.3 */

#undef CMU_MACH		/* Use CMU's MACH ioctl(FIOCFSPARAM) for dfree(). */

#undef	USG		/* System V support */

#undef NDBM		/* Use new-style (4.3) ndbm(3x) libraries */

#undef	DBM		/* True if we want to use the old dbm(3x) libraries */
			/* IF YOU DEFINE THIS, change CFLAGS in makefile to */
			/* be -ldbm */

#define	DBZ		/* True if we want to use dbz libraries */
			/* IF YOU DEFINE THIS, change CFLAGS in makefile to */
			/* be /usr/lib/dbz.o and install dbz.h */

#undef	USGHIST		/* Use USG style history file (no DBM) */
			/* IF YOU DO NOT DEFINE NDBM or DBM, this is DEFAULT!*/

#undef U_LONG		/* Define this if your <sys/types.h> is missing */
			/* typedefs for u_long */

/* For this client library, unless you have memory limits, you should just 
 * leave XHDR & XTHREAD defined.  They only mean that the library supports 
 * the commands.  The reader does not have to support the commands.  
 */
#define	XHDR		/* Optional XHDR command.  Defining this will */
			/* speed up '=' command in rn */

/* XTHREAD : note for clientlib support, thread files are in the spooldir */
#define XTHREAD		/* Optional XTHREAD command.  This allows trn to
			 * keep all data on the server. */

/*
 * Some commonly used programs and files.
 */

#define	ACTIVE_FILE		"active"
#define ACTIVE_TIMES_FILE	"active.times"
#define NEWSGROUPS_FILE		"newsgroups"
#define DISTRIBUTIONS_FILE	"distributions"
#define HISTORY_FILE		"history"
#define	SPOOLDIR		"/cdrom/spool"
#define LIBDIR			"/cdrom/lib"


/************************************************************************/
/* We don't recommend that you make changes in anything after this line */
/************************************************************************/
#define ACTIVE_TIMES_FILE_ISO	"active.tim"
#define	ACTIVE_FILE_ISO		"active"
#define NEWSGROUPS_FILE_ISO	"newsgrps"
#define XRF_SUFFIX      ".xrf"  /* for ISO 9660 cross listings */

#ifdef XTHREAD
#define ISO_THREAD "/thread"
#define UNIX_THREAD "/.thread" 
#endif

#ifdef DBZ		/* If you use DBZ, then you need DBM as well. */
#ifndef DBM
#define DBM
#endif /* DBM */
#endif /* DBZ */

#ifdef BSD_42		/* This is a logical, warranted assumption */
#   ifndef DBM		/* which will probably get me in trouble. */
#	define DBM	/* Kill it if you have 4.2 *and* ndbm.  */
#   endif /* not DBM */
#   ifndef sun		/* not a sun */
#       ifndef ultrix   /* not ultrix */
#           ifndef CMU_MACH /* not CMU's Mach */
#		ifndef NeXT /* not a NeXT */
#                  ifndef READ_SUPER
#	                define READ_SUPER /* read super block for space() */
#		    endif
#               endif
#           endif
#       endif
#   endif
#endif /* BSD_42 */

#ifndef USG
#    ifndef BSD_42
#        ifndef CMU_MACH
#            ifndef BSD_43
#                define BSD_43
#            endif
#        endif
#    endif
#endif

#ifdef BSD_43		/* And now more assumptions! */
#   ifndef sun
#	ifndef ultrix	/* Ultrix 4.0 or greater */
#		ifndef READ_SUPER
#			define READ_SUPER
#		endif
#	endif
#   endif
#	ifndef DBZ
#		ifndef DBM
#			ifndef NDBM
#				define NDBM
#			endif
#		endif
#	endif
#endif

/*
 * System V compatability
 */

#ifdef USG
# define	FCNTL			/* If O_etc is defined in <fcntl.h> */
#ifdef dgux
#define		FTRUNCATE
#else
# define	NDIR			/* If you  need ndir library support */
#ifdef hpux
#define		DIRSIZ_MACRO
#endif
#endif
# define	index	strchr
# define	rindex	strrchr
# ifdef U_LONG
   typedef	unsigned long	u_long;
   typedef	unsigned short	u_short;
# endif /* U_LONG */
# define	IPPORT_NNTP	119
#endif /* USG */


/*
 * Some miscellaneous stuff you probably don't want to change.
 */

#define	MAX_ARTICLES	16384		/* Maximum number of articles/group */
#define READINTVL	60 * 10		/* 10 minutes b/n chking active file */
