#ifndef lint
static char	*sccsid = "@(#)group.c	1.12	(Berkeley) 5/11/89";
#endif

#include "common.h"
#include "spooldir.h"

extern struct spooldir spdir;
extern char group_dir[];

#ifdef XTHREAD
extern char *thread_filename();
#endif

/*
 * GROUP newsgroup
 *
 * Change the current group to the specified newsgroup.
 * We also change our current directory to that newsgroup if
 * a spool directory for it exists.
 * If the newsgroup specified is invalid, the old newsgroup
 * remains selected.
 */

group(argc, argv)
int	argc;
char	*argv[];
{
    int  templen;
    int	 high_msg, low_msg;
    char *cp;
    char *reqlist[2];

    state_cb.state = SINGLE_RESP_STATE;

    if (argc != 2) {
	(void) sprintf(response_text, 
                       "%d Usage: GROUP newsgroup.\r\n", ERR_CMDSYN);
	return;
    }

    if (index(argv[1], '/') != (char *) NULL) {
	(void) sprintf(response_text, "%d Invalid group name (bad format).\r\n",
                ERR_NOGROUP);
	return;
    }

    if (find_group(argv[1], num_groups, &low_msg, &high_msg) < 0) {
	(void) sprintf(response_text, 
                       "%d Invalid group name (not in active).\r\n",
			ERR_NOGROUP);
	return;
    }

    reqlist[0] = argv[1];
    reqlist[1] = NULL;

    if (ngpermcount) {
	if (ngmatch(s1strneql, ALLBUT, ngpermlist, ngpermcount, 
                                                        reqlist, 1) == 0) {
	    (void) sprintf(response_text, 
                    "%d You're not allowed to read %s, sorry.\r\n",
				ERR_ACCESS, argv[1]);
	    return;
	}
    } else if (ALLBUT == 0) {
	(void) sprintf(response_text, 
                        "%d You're not allowed to read %s, sorry.\r\n",
			ERR_ACCESS, argv[1]);
	return;
    }

    close_crnt();

    (void) strcpy(group_dir, spdir.dirpath);
    (void) strcat(group_dir, "/");
    templen = strlen(group_dir);

    if (findpath(argv[1], &group_dir[templen], spdir.libpath, 
			spdir.transtype) != 1) {
	(void) sprintf(response_text, 
                        "%d %s not in translation file.\r\n",
			ERR_ACCESS, argv[1]);
	return;
    }
#ifdef PATH_DEBUG
    printf("clientlib group() - fullpath is [%s]\n", group_dir);
#endif

    num_arts = scan_dir(low_msg, high_msg);
    art_ptr = 0;

    ingroup = 1;

#ifdef XTHREAD
    threadfile = thread_filename(argv[1]);
#ifdef PATH_DEBUG
    printf("clientlib group() - threadfile is [%s]\n", threadfile);
#endif
#endif

    while ((cp = index(argv[1], '/')) != (char *) NULL)
	*cp = '.';

    (void) sprintf(response_text, "%d %d %d %d %s\r\n",
		OK_GROUP,
		num_arts,
		(num_arts > 0 ? art_array[0] : 0),
		(num_arts > 0 ? art_array[num_arts-1] : 0),
		argv[1]);
}
