#ifndef lint
static char	*sccsid = "@(#)list.c	1.11	(Berkeley) 5/11/89";
#endif

#include "common.h"
#include "spooldir.h"

extern struct newscontrol newscont;

FILE	*list_fp;
char	*grparray[2];

/*
 * LIST
 *
 * List active newsgroups, newsgroup descriptions, and distributions.
 *
 */

list(argc, argv)
int	argc;
char	*argv[];
{
    char		*filename;
    char		*items;
    char		*format;
	
    if (argc == 1 || (argc == 2 && !strcasecmp(argv[1],"active"))){
        num_groups = read_groups();
        if (num_groups == 0){ /* can't get a group list */
            state_cb.state = SINGLE_RESP_STATE;
            (void) sprintf(response_text, 
                         "%d Group update failed. Try later.\r\n", 
                         ERR_FAULT);
            return;
        }
	filename = newscont.active;
	items = "active newsgroups";
	format = "Newsgroups in form \"group high low y/n/m\".";
    } else if (argc == 2 && !strcasecmp(argv[1],"distributions")){
        filename = newscont.distributions;
	items = "newsgroup distributions";
	format = "Distributions in form \"area description\".";
    } else if (argc == 2 && !strcasecmp(argv[1],"newsgroups")){
	filename = newscont.newsgroups;
	items = "newsgroup descriptions";
	format = "Descriptions in form \"group description\".";
    } else {
        state_cb.state = SINGLE_RESP_STATE;
	(void) sprintf(response_text, 
                "%d Usage: LIST [ACTIVE|NEWSGROUPS|DISTRIBUTIONS]\r\n",
		ERR_CMDSYN);
	return;
    }

    grparray[0] = response_text;
    grparray[1] = NULL;

#ifdef PATH_DEBUG
    printf("clientlib - list() trying to open [%s]\n", filename);
#endif
    list_fp = fopen(filename, "r");

    if (list_fp == NULL) {
        state_cb.state = SINGLE_RESP_STATE;
	(void) sprintf(response_text, 
                       "%d No list of %s available.\r\n", ERR_FAULT,
			items);
	return;
    }

    state_cb.state = LIST_STATE;
    (void) sprintf(response_text, "%d %s\r\n",OK_GROUPS,format);
}


list_read()
{
    register char	*cp;

    while (fgets(response_text, NNTP_STRLEN, list_fp) != NULL) {
	if ((cp = index(response_text, '\n')) != NULL)
	    *cp = '\0';
	if (ngpermcount) {
	    if (ngmatch(s1strneql, ALLBUT, ngpermlist, ngpermcount,
			    grparray, 1) == 0)
	        continue;
	} else if (ALLBUT==0) break; /* ngpermcnt==0 && ALLBUT == 0 means
					    * don't print the list, right? */
        return; /* let get_server get the response */
    }
    (void) fclose(list_fp);
    state_cb.state = NULL_STATE;
    (void) strcpy(response_text, ".");
    return;
}
