#ifndef lint
static char	*sccsid = "@(#)$Header: nextlast.c,v 1.6 90/07/05 23:09:40 sob Exp $";
#endif

#include "common.h"

/*
 * NEXT
 * LAST
 *
 * Retrieve the message-id of the next or last article in the
 * newsgroup.  Position the current article pointer to this
 * article.
 */

nextlast(argc, argv)
	int	argc;
	char	*argv[];
{
    char artbuf[MAXPATHLEN], art_id[MAXBUFLEN];
    int	 oldptr;
    int	 next;

    /* This is a single response line command */
    state_cb.state = SINGLE_RESP_STATE;

    if (!ingroup) {
        (void) sprintf(response_text, 
                       "%d You are not currently in a newsgroup.\r\n",
			ERR_NCING);
        return;
    }

    if (argc != 1) {
        (void) sprintf(response_text, "%d NEXT/LAST need no arguments.\r\n",
                ERR_CMDSYN);
        return;
    }

    next = (argv[0][0] == 'n' || argv[0][0] == 'N');

    if (art_ptr < 0 || art_ptr >= num_arts) {
        (void) sprintf(response_text, "%d No current article selected.\r\n",
		ERR_NOCRNT);
	return;
    }

    if (next ? (art_ptr + 1 >= num_arts) : (art_ptr - 1 < 0)) {
	(void) sprintf(response_text, "%d No %s article to retrieve.\r\n",
		next ? ERR_NONEXT : ERR_NOPREV,  next ? "next" : "previous");
	return;
    }

    oldptr = art_ptr;
    (void) sprintf(artbuf, "%d", art_array[next ? ++art_ptr : --art_ptr]);

    if (!valid_art(artbuf)) {
	(void) sprintf(response_text, "%d Invalid article number: %s.\r\n",
                ERR_NOARTIG, artbuf);
	return;
    }

    while (open_valid_art(artbuf, art_id) == NULL) {
	if (((next) ? (++art_ptr >= num_arts) : (--art_ptr < 0))) {
            (void) sprintf(response_text, "%d No %s article to retrieve.\r\n",
			next ? ERR_NONEXT : ERR_NOPREV,
			next ? "next" : "previous");
	    art_ptr = oldptr;
	    return;
	}
	(void) sprintf(artbuf, "%d", art_array[art_ptr]);
    }

    (void) sprintf(response_text, 
                "%d %s %s Article retrieved; request text separately.\r\n",
		OK_NOTEXT, artbuf, art_id);

    if (argc > 1)
	art_ptr = findart(artbuf);
}
